Subject: [PATCH] sbs-battery: fix power status when battery is dry

From: [email-masked] (Sebastian Reichel)
Date: Sat, 2 Apr 2016 05:46:50 +0200

Hi,

On Thu, Mar 31, 2016 at 10:42:31AM +0800, YH Huang wrote:
> On Wed, 2016-03-30 at 17:09 +0200, Sebastian Reichel wrote:
> > Hi,
> > 
> > On Wed, Mar 30, 2016 at 04:58:30PM +0800, YH Huang wrote:
> > > If I revise the description in this way(using your clear explanation):
> > > ------------------------------------------------------------------------
> > > The battery capacity changing course is like this:
> > > 
> > > full: BATTERY_FULLY_CHARGED => POWER_SUPPLY_STATUS_FULL
> > > <unplug AC>
> > > high->low: BATTERY_DISCHARGING => POWER_SUPPLY_STATUS_DISCHARGING
> > > ~0%: DISCHARGING & FULLY_DISCHARGED => POWER_SUPPLY_STATUS_NOT_CHARGING
> > > <plug in AC>
> > > 0%~20%: FULLY_DISCHARGED => POWER_SUPPLY_STATUS_CHARGING
> > > 20%~: No flag => POWER_SUPPLY_STATUS_CHARGING
> > > 
> > > For now, it is not exactly right to show the status as
> > > POWER_SUPPLY_STATUS_NOT_CHARGING when the battery is dry
> > > (FULLY_DISCHARGED) and AC is plugged in.
> > > Although the battery is in a low level, system works fine with the AC
> > > charging.
> > > It is better to say that the battery is charging.
> > > ------------------------------------------------------------------------
> > > 
> > > How about this?
> > > By the way, should I also revise the title?
> > 
> > POWER_SUPPLY_STATUS_NOT_CHARGING is used for AC connected, but
> > battery not charging (e.g. because battery temperature is out
> > of acceptable range). If you are discharging use
> > POWER_SUPPLY_STATUS_DISCHARGING.
> > 
> > You should just ignore the FULLY_DISCHARGED bit in the status
> > property. If you don't want to loose the information about fully
> > discharged battery add POWER_SUPPLY_PROP_CAPACITY_LEVEL, which maps:
> > 
> > BATTERY_FULLY_CHARGED => POWER_SUPPLY_CAPACITY_LEVEL_FULL
> > FULLY_DISCHARGED => POWER_SUPPLY_CAPACITY_LEVEL_CRITICAL
> > otherwise => POWER_SUPPLY_CAPACITY_LEVEL_NORMAL
> 
> Oops.
> It looks like I misunderstand POWER_SUPPLY_STATUS_NOT_CHARGING.
> As Daniel said before, we could just ignore FULLY_DISCHARGED.
> 
> So change like the
> 
> sbs-battery: fix power status when battery charging near
> dry
> 
> POWER_SUPPLY_STATUS_NOT_CHARGING is used for AC connected, but
> battery not charging (e.g. because battery temperature is out
> of acceptable range).
> 
> When battery is charging near dry and BATTERY_FULL_DISCHARGED is set,
> it is wrong to set as POWER_SUPPLY_STATUS_NOT_CHARGING.
> Just use BATTERY_DISCHARGING to decide the power supply status is
> discharging or charging.
> 
>                 if (ret & BATTERY_FULL_CHARGED)
>                         val->intval = POWER_SUPPLY_STATUS_FULL;
> -               else if (ret & BATTERY_FULL_DISCHARGED)
> -                       val->intval = POWER_SUPPLY_STATUS_NOT_CHARGING;
>                 else if (ret & BATTERY_DISCHARGING)
>                         val->intval = POWER_SUPPLY_STATUS_DISCHARGING;
> 

Yes, that looks fine. Can you send this correctly formated for git?

-- Sebastian
-------------- next part --------------
A non-text attachment was scrubbed...
Name: signature.asc
Type: application/pgp-signature
Size: 819 bytes
Desc: not available
URL: <http://lists.infradead.org/pipermail/linux-arm-kernel/attachments/20160402/11dc6b50/attachment.sig>